<?php
/**
 * Call2Pay API Demo - logic file
 * version 1.0
 * 
 * author: Thorsten Kugler 
 * email: info@micropayment.de
 * supported 2009 by micropayment
 */

	require_once( 'config.php' );
	require_once( 'tools.php' );

	$action = getPostVar('action');

	
//---------------------------------------------------------------------
	if ($action == 'reCalc') {
		
		session_name('call2pay');
		session_start();
		
		//check if $count is (number && <= 0)
		$_SESSION['amount'] = 0;
		$aCount = getPostVar('count');
		$aProducts = getPostVar('product');

		$c = 0;
		//recalc amount and write back to session
		foreach ($aProducts as $product) {
			if (($aCount[$c] >= 0) && (preg_match("/^\d*$/", $aCount[$c]))) {
				$_SESSION['products'][$product] = $aCount[$c];
				foreach  ($_SESSION['products'] as $product => $count) {
					$_SESSION['amount'] +=  ($aProductList[$product]['amount'] * $count);
				}
			}
			$c += 1;
		}
		header("Location: ./shoppingbag.php");
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------		
	elseif ($action == 'getStatus') {
		
		session_name('call2pay');
		session_start();

		//create service object
		$oStatus = new c2pService();	
		$oStatus -> setParameter('action', 'status');
		$oStatus -> setParameter('handle', getPostVar('handle'));
		
		//call service function, handle errors
		if (!$oStatus -> request()) { $error = '4001'; } 
		else {
			$error = $oStatus -> getResult('error', 0);
			$errormessage = $oStatus -> getResult('errormessage');
		}	
		//error
		if ($error != 0)  return false;		

		
		// handle return
		$return = array (
			'status' => $oStatus -> getResult('status'),
			'expire' => $oStatus -> getResult('expire'),
			'caller' => $oStatus -> getResult('caller'),
			'origin' => $oStatus -> getResult('origin'),
			'duration' => $oStatus -> getResult('duration'),
			'durationpart' => $oStatus -> getResult('durationpart'),
			'freeparam' => $oStatus -> getResult('freeparam'),		
			'split' => $oStatus -> getResult('split'),
			'paid' => $oStatus -> getResult('paid'),
			'callcnt' => $oStatus -> getResult('callcnt')
		);
		
		//link to download page
		if ($return['status'] == 'COMPLETE') {
				print '<SCRIPT language="JavaScript">window.location="./complete.php";</SCRIPT>'; 
				exit(0);
		}
		
		//multicall mode
		if (getPostVar('multicall') == '1') {
			
			//broken call
			if ($return['status'] == 'RECALL') {
				$_SESSION['recall'] = 1; 
				print '<SCRIPT language="JavaScript">window.location="./precall.php";</SCRIPT>';
				exit(0);
			};
			
			//STATUS REINIT when new call for multicall
			if (($return['status'] == 'REINIT') && ($_SESSION['tmp'] != '1')) {
				$_SESSION['error'] = '3009';
				//problem is that status=REINIT is set at the beginning CALL too
				$_SESSION['tmp'] = '1';
				print '<SCRIPT language="JavaScript">window.location="./precall.php";</SCRIPT>';
			}
			
			if ($return['status'] == 'CALL') {
				$_SESSION['tmp'] = '0';
			}
		} 
		//no multicall
		else {
			//broken call
			if ($return['status'] == 'RECALL') {
				$_SESSION['recall'] = 1; 
				print '<SCRIPT language="JavaScript">window.location="./precall.php";</SCRIPT>';
				exit(0);
			}
		}
				
		$_SESSION['durationpart'] = $oStatus -> getResult('duration');
		
		//show progress bar in %
		print "<table width='300' style='border:1px solid #5a7411;'>
					<tr>
						<td>";
		print 				"<img src='./img/progressbar.jpg' align='absmiddle' height='5' width='".(100 * ($return['durationpart'] / $return['duration']))."%'>";
		print 			"</td>
					</tr>
				</table>";
		//print (100 * ($return['durationpart'] / $return['duration']))."% erledigt...<br />";

		exit(0);		
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------		
	elseif ($action == 'doCall') {
		
		session_name('call2pay');
		session_start();

		//create service object
		$oCall = new c2pService();	
		$oCall -> setParameter('action', 'testcall');
		$oCall -> setParameter('number', $_SESSION['number']);
		$oCall -> setParameter('origin', 'LANDLINE');
		$oCall -> setParameter('caller', $_SESSION['caller']);
		$oCall -> setParameter('tan', $_SESSION['tan']);
		$oCall -> setParameter('durationpart', $_SESSION['secs']);

		//call service and handle results
		if (!$oCall -> request()) { 
			$error = '0001'; 
		} 
		else {
			$error = $oCall -> getResult('error', 0);
			$errormessage = $oCall -> getResult('errormessage');
		}	
		
		//error
		if ($error != 0)  {
			$_SESSION['errormessage'] = $oCall -> getResult('errormessage'); 
			$_SESSION['error'] = $oCall -> getResult('error', 0);
			print '<SCRIPT language="JavaScript">window.location="./precall.php";</SCRIPT>';
			exit(0);
		}
		exit(0);		
	} 
//---------------------------------------------------------------------
	
//---------------------------------------------------------------------
	else {
		//no GET/POST-variables -> link to demo-shop
		header("Location: index.php");
	}
//---------------------------------------------------------------------	
?>